<?
function Neumond($k){
    $k = floor($k);
    $t = $k / 1236.85;
    $e = Var_e($t);
    $m = Var_m($k, $t);
    $m1 = Var_m1($k, $t);
    $f = Var_f($k, $t);
    $o = Var_o($k, $t);
    //Neumondkorrekturen
    $JDE = Var_JDE($k, $t);
    $JDE += (-1) * 0.4072 * SN($m1) + 0.17241 * $e * SN($m) + 0.01608 * SN(2 * $m1) + 0.01039 * SN(2 * $f) + 0.00739 * $e * SN($m1 - $m) - 0.00514 * $e * SN($m1 + $m) + 0.00208 * $e * $e * SN(2 * $m) - 0.00111 * SN($m1 - 2 * $f) - 0.00057 * SN($m1 + 2 * $f);
    $JDE += 0.00056 * $e * SN(2 * $m1 + $m) - 0.00042 * SN(3 * $m1) + 0.00042 * $e * SN($m + 2 * $f) + 0.00038 * $e * SN($m - 2 * $f) - 0.00024 * $e * SN(2 * $m1 - $m) - 0.00017 * SN($o) - 0.00007 * SN($m1 + 2 * $m) + 0.00004 * SN(2 * $m1 - 2 * $f);
    $JDE += 0.00004 * SN(3 * $m) + 0.00003 * SN($m1 + $m - 2 * $f) + 0.00003 * SN(2 * $m1 + 2 * $f) - 0.00003 * SN($m1 + $m + 2 * $f) + 0.00003 * SN($m1 - $m + 2 * $f) - 0.00002 * SN($m1 - $m - 2 * $f) - 0.00002 * SN(3 * $m1 + $m);
    $JDE += .00002 * SN(4 * $m1);
    return Korrektur($JDE, $t, $k);
  }

  function Viertel($k, $modus){
    // modus = .25 = Erstes Viertel, modus = .75 = Letztes Viertel
    $k = floor($k) + $modus;
    $t = $k / 1236.85;
    $e = Var_e($t);
    $m = Var_m($k, $t);
    $m1 = Var_m1($k, $t);
    $f = Var_f($k, $t);
    $o = Var_o($k, $t);
    // Viertelmondkorrekturen
    $JDE = Var_JDE($k, $t);
    $JDE += -.62801 * SN($m1) + .17172 * $e * SN($m) - .01183 * $e * SN($m1 + $m) + .00862 * SN(2 * $m1) + .00804 * SN(2 * $f) + .00454 * $e * SN($m1 - $m) + .00204 * $e * $e * SN(2 * $m) - .0018 * SN($m1 - 2 * $f) - .0007 * SN($m1 + 2 * $f);
    $JDE += -.0004 * SN(3 * $m1) - .00034 * $e * SN(2 * $m1 - $m) + .00032 * $e * SN($m + 2 * $f) + .00032 * $e * SN($m - 2 * $f) - .00028 * $e * $e * SN($m1 + 2 * $m) + .00027 * $e * SN(2 * $m1 + $m) - .00017 * SN($o);
    $JDE += -.00005 * SN($m1 - $m - 2 * $f) + .00004 * SN(2 * $m1 + 2 * $f) - .00004 * SN($m1 + $m + 2 * $f) + .00004 * SN($m1 - 2 * $m) + .00003 * SN($m1 + $m - 2 * $f) + .00003 * SN(3 * $m) + .00002 * SN(2 * $m1 - 2 * $f);
    $JDE += .00002 * SN($m1 - $m + 2 * $f) - .00002 * SN(3 * $m1 + $m);
    $w = .00306 - .00038 * $e * CS($m) + .00026 * CS($m1) - .00002 * CS($m1 - $m) + .00002 * CS($m1 + $m) + .00002 * CS(2 * $f);
    if ($modus == .25) {$JDE += $w;} else {$JDE += (-1)*$w;}
    return Korrektur($JDE, $t, $k);
  }

  function Vollmond($k){
    $k = floor($k) + .5;
    $t = $k / 1236.85;
    $e = Var_e($t);
    $m = Var_m($k, $t);
    $m1 = Var_m1($k, $t);
    $f = Var_f($k, $t);
    $o = Var_o($k, $t);
    //Vollmondkorrekturen
    $JDE = Var_JDE($k, $t);
    $JDE += -.40614 * SN($m1) + .17302 * $e * SN($m) + .01614 * SN(2 * $m1) + .01043 * SN(2 * $f) + .00734 * $e * SN($m1 - $m) - .00515 * $e * SN($m1 + $m) + .00209 * $e * $e * SN(2 * $m) - .00111 * SN($m1 - 2 * $f) - .00057 * SN($m1 + 2 * $f);
    $JDE += .00056 * $e * SN(2 * $m1 + $m) - .00042 * SN(3 * $m1) + .00042 * $e * SN($m + 2 * $f) + .00038 * $e * SN($m - 2 * $f) - .00024 * $e * SN(2 * $m1 - $m) - .00017 * SN($o) - .00007 * SN($m1 + 2 * $m) + .00004 * SN(2 * $m1 - 2 * $f);
    $JDE += .00004 * SN(3 * $m) + .00003 * SN($m1 + $m - 2 * $f) + .00003 * SN(2 * $m1 + 2 * $f) - .00003 * SN($m1 + $m + 2 * $f) + .00003 * SN($m1 - $m + 2 * $f) - .00002 * SN($m1 - $m - 2 * $f) - .00002 * SN(3 * $m1 + $m);
    $JDE += .00002 * SN(4 * $m1);
    return Korrektur($JDE, $t, $k);
  }

  function Korrektur($JDE, $t, $k){
    //Zustzlichen Korrekturen
    $JDE += .000325 * SN(299.77 + .107408 * $k - .009173 * $t * $t) + .000165 * SN(251.88 + .016321 * $k) + .000164 * SN(251.83 + 26.651886 * $k) + .000126 * SN(349.42 + 36.412478 * $k) + .00011 * SN(84.66 + 18.206239 * $k);
    $JDE += .000062 * SN(141.74 + 53.303771 * $k) + .00006 * SN(207.14 + 2.453732 * $k) + .000056 * SN(154.84 + 7.30686 * $k) + .000047 * SN(34.52 + 27.261239 * $k) + .000042 * SN(207.19 + .121824 * $k) + .00004 * SN(291.34 + 1.844379 * $k);
    $JDE += .000037 * SN(161.72 + 24.198154 * $k) + .000035 * SN(239.56 + 25.513099 * $k) + .000023 * SN(331.55 + 3.592518 * $k);
    return $JDE;
  }

  function Finsternis($k, $Typ, $Modus){
    // Typ = .5 = Mondfinsternis; Typ = 0 = Sonnenfinsternis
    // Modus = 0 = Finsternis partiell, Modus = 1 = Finsternis total, Modus = 2 = Sonnenfinsternis ringfrmig
    $k = floor($k) + $Typ;
    $t = $k / 1236.85;
    $f = Var_f($k, $t);
    $JDE = 0;
    $Ringtest = 0;
    if(SN(abs($f)) <= .36){
      $o = Var_o($k, $t);
      $f1 = $f - .02665 * SN($o);
      $a1 = 299.77 + .107408 * $k - .009173 * $t * $t;
      $e = Var_e($t);
      $m = Var_m($k, $t);
      $m1 = Var_m1($k, $t);
      $p = .207 * $e * SN($m) + .0024 * $e * SN(2 * $m) - .0392 * SN($m1) + .0116 * SN(2 * $m1) - .0073 * $e * SN($m1 + $m) + .0067 * $e * SN($m1 - $m) + .0118 * SN(2 * $f1);
      $q = 5.2207 - .0048 * $e * CS($m) + .002 * $e * CS(2 * $m) - .3299 * CS($m1) - .006 * $e * CS($m1 + $m) + .0041 * $e * CS($m1 - $m);
      $g = ($p * CS($f1) + $q * SN($f1)) * (1 - .0048 * CS(abs($f1)));
      $u = .0059 + .0046 * $e * CS($m) - .0182 * CS($m1) + .0004 * CS(2 * $m1) - .0005 * CS($m + $m1);
      $JDE = Var_JDE($k, $t);
      if ($Typ) { $JDE += - .4065 * SN($m1) + .1727 * $e * SN($m); } else { $JDE += - .4075 * SN($m1) + .1721 * $e * SN($m); }
      $JDE += .0161 * SN(2 * $m1) - .0097 * SN(2 * $f1) + .0073 * $e * SN($m1 - $m) - .005 * $e * SN($m1 + $m) - .0023 * SN($m1 - 2 * $f1) + .0021 * $e * SN(2 * $m);
      $JDE += .0012 * SN($m1 + 2 * $f1) + .0006 * $e * SN(2 * $m1 + $m) - .0004 * SN(3 * $m1) - .0003 * $e * SN($m + 2 * $f1) + .0003 * SN($a1) - .0002 * $e * SN($m - 2 * $f1) - .0002 * $e * SN(2 * $m1 - $m) - .0002 * SN($o);
      if($Typ){
        if((1.0248 - $u - abs($g)) / .545 <= 0) {$JDE = 0;} // keine Mf
        if($Modus == 0 && (1.0128 - $u - abs($g)) / .545 > 0 && (.4678 - $u) * (.4678 - $u) - $g * $g > 0) {$JDE = 0;} // keine partielle Mf
        if($Modus == 1 && ((1.0128 - $u - abs($g)) / .545 <= 0 != (.4678 - $u) * (.4678 - $u) - $g * $g <= 0)) {$JDE = 0;} // keine totale Mf
      }
      else{
        if(abs($g) > 1.5433 + $u) $JDE = 0; // keine SF
        if($Modus == 0 && (($g >= -.9972 && $g <= .9972) || (abs($g) >= .9972 && abs($g) < .9972 + abs($u)))) {$JDE = 0;} // keine partielle Sf
        if($Modus > 0){
           if(($g < -.9972 || $g > .9972) || (abs($g) < .9972 && abs($g) > .9972 + abs($u))) {$JDE = 0;} // keine ringfrmige oder totale SF
           //if(Modus == 1 && (u >= 0 || (g <= 0 && u < 0 || u > .0047 || u >= .00464 * Math.sqrt(1 - g * g)))) Ringtest = 1; // keine totale Sf
           if($u >= 0 || ($g <= 0 && $u < 0 || $u > .0047 || $u >= .00464 * sqrt(1 - $g * $g))) {$Ringtest = 1;} // keine totale Sf
           if ($Ringtest == 1 && $Modus == 1) {$JDE = 0;}
           if ($Ringtest == 0 && $Modus == 2) {$JDE = 0;}
        }
      }
    }
    return $JDE;
  }


  function Var_o($k, $t){
    return 124.7746 - 1.5637558 * $k + .0020691 * $t * $t + .00000215 * $t * $t * $t;
  }

  function Var_f($k, $t){
    return 160.7108 + 390.67050274 * $k - .0016341 * $t * $t - .00000227 * $t * $t * $t + .000000011 * $t * $t * $t * $t;
  }

  function Var_m1($k, $t){
    return 201.5643 + 385.81693528 * $k + .1017438 * $t * $t + .00001239 * $t * $t * $t - .000000058 * $t * $t * $t * $t;
  }

  function Var_m($k, $t){
    return 2.5534 + 29.10535669 * $k - .0000218 * $t * $t - .00000011 * $t * $t * $t;
  }

  function Var_e($t){
    return 1 - .002516 * $t - .0000074 * $t * $t;
  }

  function Var_JDE($k, $t){
    return 2451550.09765 + 29.530588853 * $k + .0001337 * $t * $t - .00000015 * $t * $t * $t + .00000000073 * $t * $t * $t * $t;
  }

  function Var_k($Jahr, $Aktdatum, $tz){
    return ($Jahr + ((date("m", time()) - 1) * 30.4 + date("d", time()) + $tz) / 365 - 2000) * 12.3685;
  }


  function Mondtag(){
    //Bezug ist der Neumond am 6.1.2001
    $Bild=0;
    $Aktdatum = time() * 1000;
    $Bildmenge = 362; // Die Menge der einzelnen Mondbilder
    $bk = 29.53059 / $Bildmenge / 5; // Ein Fnftel der Bilder-Schrittweite, bentigt zur rechtzeitigen Anzeige der Viertel
    $Jahr = date("Y", time());
    // Januar = Monat 0, wird fr k sowieso bentigt
    $k = Var_k($Jahr, $Aktdatum, 0);
    $zeit = $Aktdatum / 86400000 + 2440587.5;
    $neumond = (Neumond($k) - $zeit);
    $erstesviertel = (Viertel($k, .25) - $zeit);
    $letztesviertel = (Viertel($k, .75) - $zeit);
    $vollmond = (Vollmond($k) - $zeit);
    
    if (abs($neumond) < abs($erstesviertel) && abs($neumond) < abs($letztesviertel) && abs($neumond) < abs($vollmond)){
      $Bild = 1 - round($neumond * $Bildmenge / 29.53059);
      if ($neumond < $bk && $Bild > round($Bildmenge / 4 * 3 + 1)) {$Bild = 1;} // Damit das Bild auf jeden Fall rechtzeitg gezeigt wird.
      if ($Bild < 1) {$Bild += $Bildmenge;}
    }
    if (abs($erstesviertel) < abs($neumond) && abs($erstesviertel) < abs($letztesviertel) && abs($erstesviertel) < abs($vollmond)){
      $Bild = round($Bildmenge / 4 + 1 - $erstesviertel * $Bildmenge / 29.53059);
      if ($erstesviertel < $bk && $Bild < round($Bildmenge / 4 + 1)) {$Bild =  round($Bildmenge / 4 + 1);}
    }
    if (abs($vollmond) < abs($neumond) && abs($vollmond) < abs($letztesviertel) && abs($vollmond) < abs($erstesviertel)){
      $Bild = round($Bildmenge / 2 + 1 - $vollmond * $Bildmenge / 29.53059);
      if ($vollmond < $bk && $Bild < round($Bildmenge / 2 + 1)) {$Bild =  round($Bildmenge / 2 + 1); }
    }
    if (abs($letztesviertel) < abs($neumond) && abs($letztesviertel) < abs($vollmond) && abs($letztesviertel) < abs($erstesviertel)){
      $Bild = $Bildmenge - round($neumond * $Bildmenge / 29.53059);
      if ($Bild > $Bildmenge) {$Bild += - $Bildmenge;}
      if ($letztesviertel < $bk && $Bild < round($Bildmenge / 4 * 3 + 1)) {$Bild =  round($Bildmenge / 4 * 3 + 1);}
    }

   if($Bild < 10) $sbild = "00".$Bild; 
   elseif($Bild < 100) $sbild = "0".$Bild; 
   else $sbild = $Bild;
  
    return $sbild;
  }
  
  function JD_Stunde($JDE){
    return floor((24 * ($JDE - floor($JDE))));
  }
  
  function JD_Minute($JDE){
    return floor(($JDE - floor($JDE)) * 1440 - JD_Stunde($JDE) * 60);
  }
  
  function JD_Sekunde($JDE){
    return floor(($JDE - floor($JDE)) * 86400 - JD_Stunde($JDE) * 3600 - JD_Minute($JDE) * 60);
  }
  
  function CS($x){
    return cos($x * .0174532925199433);
  }
  
  function SN($x){
    return sin($x * .0174532925199433);
  }
?>